﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Infragistics.Controls;
using System.Collections.ObjectModel;

namespace XamZoomarWidth
{
    /// <summary>
    /// Interaction logic for SecWindow.xaml
    /// </summary>
    public partial class SecWindow : Window
    {
        private ObservableCollection<ChartData> _data;
        public SecWindow()
        {
            InitializeComponent();

        }

        private void zoombar1_ZoomChanged_1(object sender, ZoomChangedEventArgs e)
        {
            var zoombar = sender as XamZoombar;
            var range = zoombar.Range;

            //MessageBox.Show($"Min={(range.Minimum)},Max ={range.Maximum}");
            //DateTime stTime = DateTime.Today.AddHours(9).AddMinutes(30);
            //var min = range.Minimum;
            //var max = range.Maximum;
            //xamDateTimeEditor1.Value = stTime.AddMinutes(min * 39 * 10);
            //xamDateTimeEditor2.Value = stTime.AddMinutes(max * 39 * 10);            
        }

        private void button_Click(object sender, RoutedEventArgs e)
        {
            xamDateTimeEditor1.Value = DateTime.Today.AddHours(9).AddMinutes(30);
            xamDateTimeEditor2.Value = DateTime.Today.AddHours(16).AddMinutes(0);
            _data = ChartData.GenerateData();
            DataContext = _data;
        }

        private void StTimeChanged(object sender, RoutedEventArgs e)
        {
            double minRange = 0;
            var min = 0.01;
            var max = 0.98;

            DateTime StTime = DateTime.Today.AddHours(9).AddMinutes(30);
            DateTime IntervalStartTime = Convert.ToDateTime(xamDateTimeEditor1.Value);
            var minIntervalTime = IntervalStartTime.AddSeconds(-IntervalStartTime.Second);
            minRange = (((minIntervalTime - StTime).TotalMinutes) / 39 / 10);

            minRange = (((minRange - 0.0) * (max - min)) / (1.0 - 0.0)) + min;
            zoombar1.Range.Minimum = minRange;
        }

        private void EndTimeChanged(object sender, RoutedEventArgs e)
        {
            double maxRange = 0;
            var min = 0.02;
            var max = 0.99;

            DateTime StTime = DateTime.Today.AddHours(9).AddMinutes(30);
            DateTime IntervalEndTime = Convert.ToDateTime(xamDateTimeEditor2.Value);
            var maxIntervalTime = IntervalEndTime.AddSeconds(-IntervalEndTime.Second);
            maxRange = (((maxIntervalTime - StTime).TotalMinutes) / 39 / 10);
            maxRange = (((maxRange - 0.0) * (max - min)) / (1.0 - 0.0)) + min;
            zoombar1.Range.Maximum = maxRange;
        }
    }


    public class ChartData
    {

        public DateTime TimeStamp { get; set; }
        public double Flow { get; set; }

        public ChartData()
        {

        }

        public static ObservableCollection<ChartData> GenerateData()
        {
            var data = new ObservableCollection<ChartData>();
            var StartTime = DateTime.Today.AddHours(9).AddMinutes(30);
            for (int i = 0; i < 390; i++)
            {

                var row = new ChartData
                {
                    //TimeStamp = DateTime.Now.Add(TimeSpan.FromDays(i)),
                    TimeStamp = StartTime,
                    Flow = i * 1028266
                };
                data.Add(row);
                StartTime = StartTime.AddMinutes(1);
            }
            
            return new ObservableCollection<ChartData>(data.OrderBy(x=> x.TimeStamp).ToList());
        }
    }
}
